Index: orxonox/branches/buerli/src/game_loader.cc
===================================================================
--- orxonox/branches/buerli/src/game_loader.cc	(revision 2707)
+++ orxonox/branches/buerli/src/game_loader.cc	(revision 2707)
@@ -0,0 +1,180 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+*/
+
+
+#include "game_loader.h"
+#include "campaign.h"
+#include "world.h"
+#include "player.h"
+#include "orxonox.h"
+#include "camera.h"
+#include "command_node.h"
+#include "vector.h"
+#include "track.h"
+
+#include <string.h>
+
+
+using namespace std;
+
+
+GameLoader* GameLoader::singletonRef = 0;
+
+
+GameLoader::GameLoader () {}
+
+
+GameLoader::~GameLoader () {}
+
+
+GameLoader* GameLoader::getInstance()
+{
+  if(singletonRef == NULL)
+    singletonRef = new GameLoader();
+  return singletonRef;
+}
+
+
+Error GameLoader::init()
+{
+  if(this->currentCampaign != NULL)
+    this->currentCampaign->init();
+}
+
+
+Error GameLoader::loadCampaign(char* name)
+{
+  Error errorCode;
+  
+  this->currentCampaign = this->fileToCampaign(name);
+}
+
+Error GameLoader::loadDebugCampaign(Uint32 campaignID)
+{
+  switch(campaignID)
+    {
+      // Debug Level 0: Debug level used to test the base frame work.
+    case DEBUG_CAMPAIGN_0:
+      {
+	Campaign* debugCampaign = new Campaign();
+	World* world0 = new World(DEBUG_WORLD_0);
+	world0->setNextStoryID(DEBUG_WORLD_1);
+	debugCampaign->addEntity(world0, WORLD_ID_0);
+	World* world1 = new World(DEBUG_WORLD_1);
+	world1->setNextStoryID(WORLD_ID_GAMEEND);
+	debugCampaign->addEntity(world1, WORLD_ID_1);
+
+	this->currentCampaign = debugCampaign;
+	break;
+      }
+    }
+}
+
+Error GameLoader::start()
+{
+  if(this->currentCampaign != NULL)
+    this->currentCampaign->start();
+}
+
+
+Error GameLoader::stop()
+{
+  if(this->currentCampaign != NULL)
+    this->currentCampaign->stop();
+  this->currentCampaign = NULL;
+}
+
+
+Error GameLoader::pause()
+{
+  this->isPaused = true;
+  if(this->currentCampaign != NULL)
+    this->currentCampaign->pause();
+}
+
+
+Error GameLoader::resume()
+{
+  this->isPaused = false;
+  if(this->currentCampaign != NULL)
+    this->currentCampaign->resume();
+}
+
+Error GameLoader::free()
+{}
+
+
+
+
+
+Campaign* GameLoader::fileToCampaign(char *name)
+{
+  /* do not entirely load the campaign. just the current world
+     before start of each world, it has to be initialized so it
+     can load everything it needs into memory then.
+  */
+}
+
+
+/**
+   \brief handle keyboard commands 
+   \param cmd: the command to handle
+   \return true if the command was handled by the system
+*/
+bool GameLoader::worldCommand (Command* cmd)
+{
+  if( !strcmp( cmd->cmd, "up_world"))
+    {
+      if( !cmd->bUp) 
+	{
+	  this->nextLevel();
+	}
+      return true;
+    }
+  else if( !strcmp( cmd->cmd, "down_world"))
+    {
+      if( !cmd->bUp)
+	{
+	  this->previousLevel();
+	}
+      return true;
+    }
+  else if( !strcmp( cmd->cmd, "pause"))
+    {
+      if( !cmd->bUp)
+	{
+	  if(this->isPaused)
+	    this->resume();
+	  else
+	    this->pause();
+	}
+      return true;
+    }
+  return false;
+}
+
+void GameLoader::nextLevel()
+{
+  if(this->currentCampaign != NULL)
+    this->currentCampaign->nextLevel();
+}
+
+void GameLoader::previousLevel()
+{
+  if(this->currentCampaign != NULL)
+    this->currentCampaign->previousLevel();
+}
Index: orxonox/branches/buerli/src/game_loader.h
===================================================================
--- orxonox/branches/buerli/src/game_loader.h	(revision 2707)
+++ orxonox/branches/buerli/src/game_loader.h	(revision 2707)
@@ -0,0 +1,49 @@
+#ifndef GAME_LOADER_H
+#define GAME_LOADER_H
+
+#include "stdincl.h"
+#include "story_def.h"
+
+//-----------------------------------------------------------------------------
+// Forward declarations
+//-----------------------------------------------------------------------------
+class Campaign;
+class World;
+class Camera;
+class CammandNode;
+
+
+class GameLoader 
+{
+
+ public:
+  static GameLoader* getInstance();
+
+  Error init();
+  Error loadCampaign(char* name);
+  Error start();
+  Error stop();
+  Error pause();
+  Error resume();
+  Error free();
+
+  void nextLevel();
+  void previousLevel();
+
+  bool worldCommand(Command* cmd);
+  Error loadDebugCampaign(Uint32 campaignID);
+  
+ private:
+  GameLoader ();
+  ~GameLoader ();
+  Uint32 startTime; //!> start time of the campaign
+  static GameLoader* singletonRef;
+  bool isPaused;
+
+  Campaign* currentCampaign; //!> the current campaign playing
+  
+  Campaign* fileToCampaign(char* name);
+
+};
+
+#endif
Index: orxonox/branches/buerli/src/list.h
===================================================================
--- orxonox/branches/buerli/src/list.h	(revision 2706)
+++ orxonox/branches/buerli/src/list.h	(revision 2707)
@@ -1,2 +1,21 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christian Meyer
+
+   ADDONS/FIXES:
+  
+   Patrick Boenzli     :          Implemented getSize() function
+*/
+
+
 /*!
   \file list.h
@@ -21,4 +40,5 @@
   List<T>* prev;
   bool bReference;
+  int size;
   
  public:
@@ -35,4 +55,5 @@
   void set_prev (List<T>* ptr);
   int remove (T* obj, FINDMODE mode);
+  int getSize();
 };
 
@@ -52,4 +73,6 @@
   prev = p;
   bReference = bRef;
+  if(obj != NULL)
+    ++size;
 }
 
@@ -127,4 +150,5 @@
       break;
   }
+  ++size;
   return 0;
 }
@@ -224,4 +248,5 @@
     }
   }
+  --size;
   return 0;
 }
@@ -262,4 +287,13 @@
 
 
+/**
+  \brief Returns the current size of the List
+  \return Size of List
+*/
+template<class T>
+int List<T>::getSize()
+{
+  return this->size;
+}
 
 #endif
Index: orxonox/branches/buerli/src/orxonox.cc
===================================================================
--- orxonox/branches/buerli/src/orxonox.cc	(revision 2706)
+++ orxonox/branches/buerli/src/orxonox.cc	(revision 2707)
@@ -29,4 +29,5 @@
 #include "data_tank.h"
 #include "command_node.h"
+#include "game_loader.h"
 #include <string.h>
 
@@ -34,5 +35,5 @@
 
 /**
-	\brief create a new Orxonox
+   \brief create a new Orxonox
 */
 Orxonox::Orxonox ()
@@ -42,13 +43,13 @@
 
 /**
-	\brief remove Orxonox from memory
+   \brief remove Orxonox from memory
 */
 Orxonox::~Orxonox () 
 {
-	Orxonox::singleton_ref = NULL;
-	if( world != NULL) delete world;
-	if( localinput != NULL) delete world;
-	if( localcamera != NULL) delete localcamera;
-	if( resources != NULL) delete resources;
+  Orxonox::singleton_ref = NULL;
+  if( world != NULL) delete world;
+  if( localinput != NULL) delete world;
+  if( localcamera != NULL) delete localcamera;
+  if( resources != NULL) delete resources;
 }
 
@@ -65,63 +66,63 @@
 
 /**
-	\brief this finds the config file
-	
-	Since the config file varies from user to user and since one may want to specify different config files
-	for certain occasions or platforms this function finds the right config file for every occasion and stores
-	it's path and name into configfilename
+   \brief this finds the config file
+   
+   Since the config file varies from user to user and since one may want to specify different config files
+   for certain occasions or platforms this function finds the right config file for every occasion and stores
+   it's path and name into configfilename
 */
 void Orxonox::get_config_file (int argc, char** argv)
 {
-/*	char* path;
-	#ifdef __WIN32__
-	path = getenv("");
-	#else
-	path = getenv("HOME");
-	#endif
-	
-	if( path != NULL) strcpy (configfilename, path);
-	else strcpy (configfilename, "./");
-	strcat (configfilename, "/.orxonox.conf");*/
-	
-	strcpy (configfilename, "orxonox.conf");
-}
-
-/**
-	\brief initialize Orxonox with command line
+  /*	char* path;
+    #ifdef __WIN32__
+    path = getenv("");
+    #else
+    path = getenv("HOME");
+    #endif
+    
+    if( path != NULL) strcpy (configfilename, path);
+    else strcpy (configfilename, "./");
+    strcat (configfilename, "/.orxonox.conf");*/
+  
+  strcpy (configfilename, "orxonox.conf");
+}
+
+/**
+   \brief initialize Orxonox with command line
 */
 int Orxonox::init (int argc, char** argv)
 {
-		// parse command line
-		// config file
-		
-	get_config_file (argc, argv);
-	
-		// initialize SDL
+  // parse command line
+  // config file
+  
+  get_config_file (argc, argv);
+  
+  // initialize SDL
   printf("> Initializing SDL\n");
   if( SDL_Init (SDL_INIT_EVERYTHING) == -1)
-  {
-    printf ("Could not SDL_Init(): %s\n", SDL_GetError());
-    return -1;
-  }
-  
-  	// initialize everything
+    {
+      printf ("Could not SDL_Init(): %s\n", SDL_GetError());
+      return -1;
+    }
+  
+  // initialize everything
   printf("> Initializing video\n");
-	if( init_video () == -1) return -1;
+  if( init_video () == -1) return -1;
   printf("> Initializing sound\n");
-	if( init_sound () == -1) return -1;
+  if( init_sound () == -1) return -1;
   printf("> Initializing input\n");
-	if( init_input () == -1) return -1;
+  if( init_input () == -1) return -1;
   printf("> Initializing networking\n");
-	if( init_networking () == -1) return -1;
+  if( init_networking () == -1) return -1;
   printf("> Initializing resources\n");
-	if( init_resources () == -1) return -1;
-  printf("> Initializing world\n");
-	if( init_world () == -1) return -1;
-	
-	return 0;
-}
-
-/**
-	\brief initializes SDL and OpenGL
+  if( init_resources () == -1) return -1;
+  //printf("> Initializing world\n");
+  //if( init_world () == -1) return -1; PB: world will be initialized when started
+  
+  return 0;
+}
+
+/**
+   \brief initializes SDL and OpenGL
 */
 int Orxonox::init_video () 
@@ -161,70 +162,88 @@
   
   // create camera
-  localcamera = new Camera();
-  
-  return 0;
-}
-
-/**
-	\brief initializes the sound engine
+  localcamera = new Camera(world);
+  
+  return 0;
+}
+
+/**
+   \brief initializes the sound engine
 */
 int Orxonox::init_sound () 
 {
-	printf("Not yet implemented\n");
-	return 0;
-}
-
-/**
-	\brief initializes input functions
+  printf("Not yet implemented\n");
+  return 0;
+}
+
+/**
+   \brief initializes input functions
 */
 int Orxonox::init_input () 
 {
-	// create localinput
-	localinput = new CommandNode( configfilename);
-	
-	return 0;
-}
-
-/**
-	\brief initializes network system
+  // create localinput
+  localinput = new CommandNode( configfilename);
+  
+  return 0;
+}
+
+/**
+   \brief initializes network system
 */
 int Orxonox::init_networking () 
 {
-	printf("Not yet implemented\n");
-	return 0;
-}
-
-/**
-	\brief initializes and loads resource files
+  printf("Not yet implemented\n");
+  return 0;
+}
+
+/**
+   \brief initializes and loads resource files
 */
 int Orxonox::init_resources () 
 {
-	printf("Not yet implemented\n");
-	return 0;
-}
-
-/**
-	\brief initializes the world
+  printf("Not yet implemented\n");
+  return 0;
+}
+
+/**
+   \brief initializes the world
 */
 int Orxonox::init_world () 
 {
-	world = new World();
-	
-	// TO DO: replace this with a menu/intro
-	world->load_debug_level();
-	
-	return 0;
-}
-
-/**
-	\brief exits Orxonox
+  //world = new World();
+  
+  // TO DO: replace this with a menu/intro
+  //world->load_debug_level();
+  
+  return 0;
+}
+
+
+/**
+   \brief starts the orxonox game or menu
+
+   here is the central orxonox state manager. There are currently two states
+   - menu
+   - game-play
+   both states manage their states themselfs again.
+*/
+void Orxonox::start()
+{
+  
+  this->gameLoader = GameLoader::getInstance();
+  this->gameLoader->loadDebugCampaign(DEBUG_CAMPAIGN_0);
+  this->gameLoader->init();
+  this->gameLoader->start();
+}
+
+/**
+   \brief exits Orxonox
 */
 void Orxonox::quitGame() 
 {
-	bQuitOrxonox = true;
-}
-
-/**
-	\brief this runs all of Orxonox
+  bQuitOrxonox = true;
+}
+
+/**
+   \brief this runs all of Orxonox
 */
 void Orxonox::mainLoop()
@@ -236,6 +255,4 @@
   while( !bQuitOrxonox)
     {
-      printf("<==");
-
       // Network
       synchronize();
@@ -248,6 +265,4 @@
       // Draw
       display();
-
-      printf(">\n");
     }
   printf("Orxonox|Exiting the main loop\n");
@@ -255,33 +270,33 @@
 
 /**
-	\brief handles sprecial events from localinput
-	\param event: an event not handled by the CommandNode 
+   \brief handles sprecial events from localinput
+   \param event: an event not handled by the CommandNode 
 */
 void Orxonox::event_handler (SDL_Event* event)
 {
-	// Handle special events such as reshape, quit, focus changes
-}
-
-/**
-	\brief synchronize local data with remote data
+  // Handle special events such as reshape, quit, focus changes
+}
+
+/**
+   \brief synchronize local data with remote data
 */
 void Orxonox::synchronize ()
 {
-	// Get remote input
-	// Update synchronizables
-}
-
-/**
-	\brief run all input processing
+  // Get remote input
+  // Update synchronizables
+}
+
+/**
+   \brief run all input processing
 */
 void Orxonox::handle_input ()
 {
-	// localinput
-		localinput->process();
-	// remoteinput
-}
-
-/**
-	\brief advance the timeline
+  // localinput
+  localinput->process();
+  // remoteinput
+}
+
+/**
+   \brief advance the timeline
 */
 void Orxonox::time_slice ()
@@ -295,5 +310,5 @@
 	{
 	  float fps = 1000/dt;
-	  printf("%f", fps);
+	  printf("fps = %f\n", fps);
 	}
       
@@ -306,82 +321,84 @@
 
 /**
-	\brief compute collision detection
+   \brief compute collision detection
 */
 void Orxonox::collision ()
 {
-	world->collide ();
-}
-
-/**
-	\brief handle keyboard commands that are not meant for WorldEntities
-	\param cmd: the command to handle
-	\return true if the command was handled by the system or false if it may be passed to the WorldEntities
+  world->collide ();
+}
+
+/**
+   \brief handle keyboard commands that are not meant for WorldEntities
+   \param cmd: the command to handle
+   \return true if the command was handled by the system or false if it may be passed to the WorldEntities
 */
 bool Orxonox::system_command (Command* cmd)
 {
-	if( !strcmp( cmd->cmd, "quit"))
-	{
-		if( !cmd->bUp) bQuitOrxonox = true;
-		return true;
-	}
-	return false;
-}
-
-/**
-	\brief render the current frame
+  if( !strcmp( cmd->cmd, "quit"))
+    {
+      if( !cmd->bUp) this->gameLoader->stop();
+      return true;
+    }
+  return false;
+}
+
+/**
+   \brief render the current frame
 */
 void Orxonox::display ()
 {
-		// clear buffer
-	glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
-		// set camera
-	localcamera->apply ();
-		// draw world
-	world->draw ();
-		// draw HUD
-		// flip buffers
-	SDL_GL_SwapBuffers();
-}
-
-/**
-	\brief retrieve a pointer to the local Camera
-	\return a pointer to localcamera
+  // clear buffer
+  glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
+  // set camera
+  localcamera->apply ();
+  // draw world
+  world->draw ();
+  // draw HUD
+  // flip buffers
+  SDL_GL_SwapBuffers();
+}
+
+/**
+   \brief retrieve a pointer to the local Camera
+   \return a pointer to localcamera
 */
 Camera* Orxonox::get_camera ()
 {
-	return localcamera;
-}
-
-/**
-	\brief retrieve a pointer to the local CommandNode
-	\return a pointer to localinput
+  return localcamera;
+}
+
+/**
+   \brief retrieve a pointer to the local CommandNode
+   \return a pointer to localinput
 */
 CommandNode* Orxonox::get_localinput ()
 {
-	return localinput;
-}
-
-/**
-	\brief retrieve a pointer to the local World
-	\return a pointer to world
+  return localinput;
+}
+
+/**
+   \brief retrieve a pointer to the local World
+   \return a pointer to world
 */
 World* Orxonox::get_world ()
 {
-	return world;
+  return world;
 }
 
 int main (int argc, char** argv) 
 {  
-	printf(">>> Starting Orxonox <<<\n");
+  printf(">>> Starting Orxonox <<<\n");
   Orxonox *orx = Orxonox::getInstance();
   
   if( (*orx).init(argc, argv) == -1)
-  {
-    printf("! Orxonox initialization failed\n");
-    return -1;
-  }
-	
-  (*orx).mainLoop();
-
+    {
+      printf("! Orxonox initialization failed\n");
+      return -1;
+    }
+  
+  //(*orx).mainLoop();
+
+  orx->start();
+  
   //delete orx;
   
Index: orxonox/branches/buerli/src/orxonox.conf
===================================================================
--- orxonox/branches/buerli/src/orxonox.conf	(revision 2706)
+++ orxonox/branches/buerli/src/orxonox.conf	(revision 2707)
@@ -6,6 +6,10 @@
 SPACE=fire
 ESCAPE=quit
+p=pause
 q=quit
 BUTTON_LEFT=fire
 BUTTON_RIGHT=altfire
 b=benscho
+x=up_world
+z=down_world
+
Index: orxonox/branches/buerli/src/orxonox.h
===================================================================
--- orxonox/branches/buerli/src/orxonox.h	(revision 2706)
+++ orxonox/branches/buerli/src/orxonox.h	(revision 2707)
@@ -16,4 +16,5 @@
 class World;
 class Camera;
+class GameLoader;
 
 //! Orxonox core singleton class
@@ -33,12 +34,13 @@
   Camera* localcamera;
   SDL_Surface* screen;
+  GameLoader* gameLoader;
   
   bool bQuitOrxonox;
   bool pause;
-	Uint32 lastframe;
-
-	void get_config_file (int argc, char** argv);
-	
-		// main loop functions
+  Uint32 lastframe;
+  
+  void get_config_file (int argc, char** argv);
+  
+  // main loop functions
   void synchronize ();
   void handle_input ();
@@ -57,4 +59,5 @@
  public:
   static Orxonox* getInstance ();
+  void start();
   void quitGame();
 
@@ -63,9 +66,9 @@
 
   int init (int argc, char** argv);
-	
-	CommandNode* get_localinput();
-	Camera* get_camera();
-	World* get_world();
-	
+  
+  CommandNode* get_localinput();
+  Camera* get_camera();
+  World* get_world();
+  
   void mainLoop();
 };
Index: orxonox/branches/buerli/src/player.cc
===================================================================
--- orxonox/branches/buerli/src/player.cc	(revision 2706)
+++ orxonox/branches/buerli/src/player.cc	(revision 2707)
@@ -62,14 +62,14 @@
 void Player::command (Command* cmd)
 {
-	printf("Player|recieved command [%s]\n", cmd->cmd);
-	if( !strcmp( cmd->cmd, "up")) bUp = !cmd->bUp;
-	else if( !strcmp( cmd->cmd, "down")) bDown = !cmd->bUp;
-	else if( !strcmp( cmd->cmd, "left")) bLeft = !cmd->bUp;
-	else if( !strcmp( cmd->cmd, "right")) bRight = !cmd->bUp;
-	else if( !strcmp( cmd->cmd, "fire")) bFire = !cmd->bUp;
+  //printf("Player|recieved command [%s]\n", cmd->cmd);
+  if( !strcmp( cmd->cmd, "up")) bUp = !cmd->bUp;
+  else if( !strcmp( cmd->cmd, "down")) bDown = !cmd->bUp;
+  else if( !strcmp( cmd->cmd, "left")) bLeft = !cmd->bUp;
+  else if( !strcmp( cmd->cmd, "right")) bRight = !cmd->bUp;
+  else if( !strcmp( cmd->cmd, "fire")) bFire = !cmd->bUp;
 }
 
 void Player::draw ()
-{
+{ 
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
Index: orxonox/branches/buerli/src/stdincl.h
===================================================================
--- orxonox/branches/buerli/src/stdincl.h	(revision 2706)
+++ orxonox/branches/buerli/src/stdincl.h	(revision 2707)
@@ -15,4 +15,5 @@
 #include "coordinates.h"
 #include "list.h"
+#include "error.h"
 #include "message_structures.h"
 #include "orxonox.h"
Index: orxonox/branches/buerli/src/story_def.h
===================================================================
--- orxonox/branches/buerli/src/story_def.h	(revision 2707)
+++ orxonox/branches/buerli/src/story_def.h	(revision 2707)
@@ -0,0 +1,24 @@
+
+#ifndef STORY_DEF_H
+#define STORY_DEF_H
+
+
+#define DEBUG_CAMPAIGN_0 0
+#define DEBUG_CAMPAIGN_1 1
+#define DEBUG_CAMPAIGN_2 2
+
+#define DEBUG_WORLD_0 0
+#define DEBUG_WORLD_1 1
+#define DEBUG_WORLD_2 2
+
+#define WORLD_ID_0 0
+#define WORLD_ID_1 1
+#define WORLD_ID_2 2
+#define WORLD_ID_3 3
+#define WORLD_ID_4 4
+#define WORLD_ID_5 5
+#define WORLD_ID_GAMEEND 999
+
+#define MAX_STORY_ENTITIES 99; //!> maximal StoryEntities in a Campaign
+
+#endif
Index: orxonox/branches/buerli/src/story_entity.cc
===================================================================
--- orxonox/branches/buerli/src/story_entity.cc	(revision 2707)
+++ orxonox/branches/buerli/src/story_entity.cc	(revision 2707)
@@ -0,0 +1,87 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: 
+*/
+
+
+#include "story_entity.h"
+
+
+using namespace std;
+
+
+
+StoryEntity::StoryEntity () {}
+StoryEntity::~StoryEntity () {}
+
+
+/** 
+    \brief initialize the entity before use. 
+
+    After execution of this function, the Entity is ready to be played/executed, 
+    this shifts the initialisation work before the execution - very important...
+    
+*/
+Error StoryEntity::init()
+{}
+
+
+void StoryEntity::setStoryID(Uint32 storyID)
+{
+  this->storyID = storyID;
+}
+
+int StoryEntity::getStoryID()
+{
+  return this->storyID;
+}
+
+
+void StoryEntity::setNextStoryID(Uint32 nextStoryID)
+{
+  this->nextStoryID = nextStoryID;
+}
+
+Uint32 StoryEntity::getNextStoryID()
+{
+  return this->nextStoryID;
+}
+
+
+Error StoryEntity::start(Uint32 storyID)
+{}
+
+Error StoryEntity::start()
+{}
+
+Error StoryEntity::stop()
+{}
+
+Error StoryEntity::pause()
+{}
+
+Error StoryEntity::resume()
+{}
+
+
+void StoryEntity::load()
+{}
+
+
+void StoryEntity::displayEntityScreen()
+{}
+
+void StoryEntity::releaseEntityScreen()
+{}
Index: orxonox/branches/buerli/src/story_entity.h
===================================================================
--- orxonox/branches/buerli/src/story_entity.h	(revision 2707)
+++ orxonox/branches/buerli/src/story_entity.h	(revision 2707)
@@ -0,0 +1,41 @@
+
+#ifndef STORY_ENTITY_H
+#define STORY_ENTITY_H
+
+#include "stdincl.h"
+#include "story_def.h"
+
+class StoryEntity {
+
+ public:
+  StoryEntity ();
+  ~StoryEntity ();
+
+  bool isInit;
+  bool isPaused;
+
+  virtual Error init();
+  virtual Error start(Uint32 storyID);
+  virtual Error start();
+  virtual Error stop();
+  virtual Error pause();
+  virtual Error resume();
+
+  virtual void load();
+
+  virtual void displayEntityScreen();
+  virtual void releaseEntityScreen();
+
+  void setStoryID(Uint32 storyID);
+  int getStoryID();
+
+  void setNextStoryID(Uint32 nextStoryID);
+  Uint32 getNextStoryID();
+
+
+ private:
+  Uint32 storyID;
+  Uint32 nextStoryID;
+};
+
+#endif
Index: orxonox/branches/buerli/src/track.cc
===================================================================
--- orxonox/branches/buerli/src/track.cc	(revision 2706)
+++ orxonox/branches/buerli/src/track.cc	(revision 2707)
@@ -52,4 +52,10 @@
 {
 }
+
+void Track::init()
+{
+  
+}
+
 
 /**
Index: orxonox/branches/buerli/src/track.h
===================================================================
--- orxonox/branches/buerli/src/track.h	(revision 2706)
+++ orxonox/branches/buerli/src/track.h	(revision 2707)
@@ -27,13 +27,14 @@
  	
  public:
- 	Track ();
+  Track ();
   Track (Uint32 number, Uint32 next, Vector* start, Vector* finish);
   ~Track ();
-	
-	virtual void post_enter (WorldEntity* entity);	// handle coordinate transition in here !!! (when dist < 0 or dist > lasttracklenght)
-	virtual void post_leave (WorldEntity* entity);
-	virtual void tick (float deltaT);
-	virtual void map_camera (Location* lookat, Placement* camplc);
-	virtual bool map_coords (Location* loc, Placement* plc);	// this should return true if the entity left track boundaries
+  virtual void init();
+  
+  virtual void post_enter (WorldEntity* entity);	// handle coordinate transition in here !!! (when dist < 0 or dist > lasttracklenght)
+  virtual void post_leave (WorldEntity* entity);
+  virtual void tick (float deltaT);
+  virtual void map_camera (Location* lookat, Placement* camplc);
+  virtual bool map_coords (Location* loc, Placement* plc);	// this should return true if the entity left track boundaries
 };
 
